# -*- coding: utf-8 -*-

from Handlers import BaseHandler
import http.client
import json
import codecs
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class Module(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self.config = "/etc/default/ppp"
		self.name = 'PPP'
		self.keys = ['START','PROVIDER','PERSIST','RESET_ON_FAIL','RESET_ALWAYS','RESET_AT','RESET_WAIT','HOLDOFF',
					 'APN','PDPTYPE','DEMAND','IDLE','DEVICE','DEFAULTROUTE','AUTH','ACCOUNT','PASSWORD']
		self.upper = ['PDPTYPE','AUTH']
		self.mw_conf = "/etc/default/mobile_watch"
	#=======================================================
	# 
	#=======================================================
	def Get(self, request):

		status = 200
		type = request.query.type
		if type == 'config':
			result = self.readConfig()
		elif type == 'status':
			result = self.getStatus()

		return result, status

	#=======================================================
	# 
	#=======================================================
	def Put(self, request):
		
		status = 200
		self.writeConfig(request.json)
		self.restart()
		return status
		
	#=======================================================
	# 
	#=======================================================
	def readConfig(self):
		
		conf = {}

		for key in self.keys:
			if key == 'RESET_AT':
				conf['RESET_AT_ENABLE'] = 'no'
				conf['RESET_AT_TIME'] = ''
			else:
				conf[key] = ''

		config = open(self.config, "r")
		for line in config:
			if line.startswith('#') == True:
				pass
			else:
				sline = line.strip('\n').split('=')
				if sline[0] in self.keys and len(sline) > 1 and sline[1]:
					
					if sline[0] == 'AUTH' or sline[0] =='PDPTYPE':
						conf[sline[0]] = sline[1].lower()
					elif sline[0] == 'RESET_AT':
						conf['RESET_AT_ENABLE'] = 'yes'
						conf['RESET_AT_TIME']  = ''.join((sline[1][:2],sline[1][3:]))
					else:
						conf[sline[0]] = sline[1]
		return conf

	#=======================================================
	# 
	#=======================================================
	def writeConfig(self, args):

		config =[]
		
		for key in self.keys:
			value = ''
			if key == 'DEVICE':
				value  = 'AUTO' 
			elif key == 'RESET_AT':
				if 'RESET_AT_ENABLE' in args and args['RESET_AT_ENABLE']=='yes':
					if 'RESET_AT_TIME' in args and args['RESET_AT_TIME']:
						value = ':'.join((args['RESET_AT_TIME'][:2],args['RESET_AT_TIME'][2:]))
			elif key in self.upper:
				value = args[key].upper()
			else:
				value = args[key]
			
			config.append('='.join((key, value)))

		fd = open(self.config, 'w')
		fd.write('\n'.join(config))

	#=======================================================
	# 
	#=======================================================
	def getStatus(self):
		
		mobile_status = {'level':None, 'carrier':None}
		mw_service = self.service_status('mobile_watch')

		if 'running' in mw_service:

			fd = open(self.mw_conf, 'r')
			for line in fd:
				sline = line.strip('\n').split('=')
				if sline[0] == 'HOST':
					host = sline[1]
				elif sline[0] == 'PORT':
					port = sline[1]

			reader = codecs.getreader("utf-8")
			conn = http.client.HTTPConnection(':'.join((host,port)))
			conn.request("GET", "/antenna")
			obj = json.load(reader(conn.getresponse()))
			
			if 'level' in obj:
				mobile_status['level'] = str(obj['level'])
			if 'carrier' in obj:
				mobile_status['carrier'] = str(obj['carrier'])

		return mobile_status

	#=======================================================
	# 
	#=======================================================
	def restart(self):

		self.service('ppp', 'restart')
