# -*- coding: utf-8 -*-
from Handlers import BaseHandler
#-------------------------------------------------------------------------------
#
#-------------------------------------------------------------------------------
class NTP(BaseHandler.BaseHandler):
	#=======================================================
	# 
	#=======================================================
	def __init__(self):
		self.config = "/etc/ntp.conf"
		self.name = 'NTP'
	#=======================================================
	# 
	#=======================================================
	def Get(self, request):
			
		status = 200
		return self.readConfig(), status

	#=======================================================
	# 
	#=======================================================
	def Put(self, request):

		status = 200
		self.writeConfig(request.json)
		self.restart(request.json)
		return status

	#=======================================================
	# 
	#=======================================================
	def readConfig(self):

		ntp_server = {'printp':'', 'secntp':'', 'ntpClient':'no'}
		status = self.call(['service','ntp','status'])
		if status == 0:
			ntp_server['ntpClient'] = 'yes'

		config = open(self.config, "r")
		for line in config:
			if line.startswith('#') == True:
				pass
			if line.startswith('server '):
				if ntp_server['printp'] == '':
					ntp_server['printp'] = line.split()[1]
				elif ntp_server['secntp'] == '':
					ntp_server['secntp'] = line.split()[1]

		return ntp_server
	#=======================================================
	# 
	#=======================================================
	def writeConfig(self, args):
		
		config = open(self.config, "r")
		read_lines = config.read()
		config.close()
		write_lines = []
		flg = False

		for line in read_lines.split('\n'):
			if line.startswith('server '):
				if not flg:
					if 'printp' in args and args['printp']:
					#if args['printp']:
						write_lines.append('server %s' %  args['printp']) 
					if 'secntp' in args and args['secntp']:
					#if args['secntp']:
						write_lines.append('server %s' % args['secntp']) 
					flg = True
			else:
				write_lines.append(line)

		config = open(self.config, "w")
		config.write('\n'.join(write_lines))

	#=======================================================
	# 
	#=======================================================
	def restart(self, args):

		if args['ntpClient']=='yes':
			action = 'restart'
			startup = 'enable'
		else:
			action = 'stop'
			startup = 'disable'

		self.service('ntp', action)
		self.update_rc(startup)

	#=======================================================
	# 
	#=======================================================
	def update_rc(self, status):

		self.call('update-rc.d ntp %s 2 3 4 5' % status, shell= True)

