# -*- coding: utf-8 -*-

from bottle import hook, response, route, request, run
from Handlers import Handler
import syslog


handler = Handler.Handler
last_data = Handler.last_data

@hook('after_request')
def enable_cors():

	response.headers['Access-Control-Allow-Origin'] = '*'
	response.headers['Access-Control-Allow-Methods'] = 'GET,POST,PUT'
	response.headers['Access-Control-Max-Age'] = '1728000'
	response.headers['Access-Control-Allow-Headers'] = 'Content-Type,Content-Disposition'
	response.headers['Cache-Control'] = 'no-cache'

@route('/service/<name>', method='OPTIONS')
def options(name):
	print("options: %s "  % name)
	return

#=======================================================
# 
#=======================================================
@route('/service/<name>', method='GET')
def get(name):
	
	print("get: %s "  % name)
	status = 400
	if name in handler:
		params,status = handler[name].Get(request)
	else:
		status = 404

	response.status = status
	return params

#=======================================================
# 
#=======================================================
@route('/service/<name>', method='PUT')
def put(name):

	print("put: %s "  % name)
	print(request.json)
	status = 400

	if name in handler:
	   status =  handler[name].Put(request)
	else:
		status = 404

	response.status = status
	
#=======================================================
# 
#=======================================================
@route('/service/<name>', method='POST')	
def post(name):

	print("post: %s "  % name)
	print(request.json)
	result = None
	status = 400
	if name == 'firmup':
		result, status =  handler[name].Post(request)
	elif name in handler:
		status = handler[name].Post(request)
	else:
		status = 404

	response.status = status
	if result:
		return result

syslog.openlog("mae appserver")
run(host='localhost', port=8080)
