#! /usr/bin/env python
# -*- coding: utf-8 -*-
#
# MA-4xx/8xx/E2xx Web Application Server Module
#
# Copyright (C) 2008-2009 Century Systems Co.,Ltd.
#

import threading
import time

class MyTimer(threading.Thread):
    def __init__(self, interval, function, args=[], kwargs={}):
        threading.Thread.__init__(self)
        self.interval = interval
        self.function = function
        self.args = args
        self.kwargs = kwargs
        self.finished = threading.Event()

    def cancel(self):
        if self.isAlive():
            self.finished.set()

    def run(self):
        cnt = 0
        while True:
            time.sleep(1)
            if self.finished.isSet():
                break

            cnt += 1
            if cnt >= self.interval:
                self.function(*self.args, **self.kwargs)
                break
